//+------------------------------------------------------------------+
//|                                           Trend following EA.mq4 |
//|                                                    Robert Maidla |
//|                               https://www.rmtradingsolutions.com |
//+------------------------------------------------------------------+
#property copyright "http://rmtradingsolutions.com"
#property link      "http://rmtradingsolutions.com"
#property version   "1.00"
#property icon      "Icon RM.ico"
#property description "This Expert Advisor is developed by Robert Maidla from RM Trading Solutions. Please visit our website to see what more we can offer you!"
#property strict
//+------------------------------------------------------------------+
//| Custom enumerations                                              |
//+------------------------------------------------------------------+
enum tradeDirection {
   L=0, //Only long
   S=1, //Only short
   B=2, //Both
};
//+------------------------------------------------------------------+
//| Inputs                                                           |
//+------------------------------------------------------------------+
input string infoTrades = "___ORDER SETTINGS___"; //.
input tradeDirection TD = 2; //Trade direction
input double volume = 0.01; //Volume
input double gridSizeInp = 10; //Stop distance pips
input int maxAllowedSlippageInp = 3; //Max allowed slippage
input int magicNumber = 7945; //Magic number for this sequence

input string gap1 = ""; //.
input string infoClose = "___CLOSE SETTINGS___"; //.
/*input double upperClosePrice = 1.5; //Upper close price
input double lowerClosePrice = 1; //Lower close price*/
input double netProfitTarget = 20; //Net profit target

input string gap2 = ""; //.
input string infoVisual = "___VISUAL SETTINGS___"; //.
input bool showGrid = true; //Show grid
input color gridColor = clrWhiteSmoke; //Grid color
input ENUM_LINE_STYLE gridStyle = STYLE_DASH; //Grid style

input string gap0 = "";//.
input string infoNF = "___NEWS FEED SETTINGS___"; //.
input bool displayNF = true; //Display news feed
//+------------------------------------------------------------------+
//| Variables                                                        |
//+------------------------------------------------------------------+
double gridSize,startPrice;
int maxAllowedSlippage;
double upperGridPrice, lowerGridPrice;
int ord_arr[500];
bool OrderClosed = false;
int tries=0;
bool runEA;
int lastBuyTicket, lastSellTicket;
double longEntryPricesArray[999];
double shortEntryPricesArray[999];
int longEntryCountArray[999];
int shortEntryCountArray[999];
datetime startTime;
double gridArray[1001];
int lastEntryIndex;

//**--TEMPLATE
datetime stopper=Time[0];
int digiter, normalizer;
double lotStep;
string NFV1, NFV2, NFV3, NFV4, NFV5, NFV6, NFV7, NFV8, NFTV1, NFTV2, NFTV3, NFTV4, NFTV5, NFTV6, NFTV7, NFTV8;
string name = "HUD";
string textUsed;
string nameNF;
bool HUDMinimized;
string InpFile="RM Trading Solutions White for MT4.bmp"; // Bitmap file name
int InpWidth=220;                    // Visibility scope X coordinate
int InpHeight=109;                   // Visibility scope Y coordinate
int InpXOffset=0;                   // Visibility scope shift by X axis
int InpYOffset=0;                   // Visibility scope shift by Y axis
color InpColor=clrRed;                // Border color when highlighted
ENUM_LINE_STYLE InpStyle=STYLE_SOLID;           // Line style when highlighted
int InpPointWidth=1;                // Point size to move
bool InpBack=false;                  // Background object
bool InpSelection=false;             // Highlight to move
bool InpHidden=true;                 // Hidden in the object list
long InpZOrder=1;                    // Priority for mouse click
//+------------------------------------------------------------------+
//|                       TEMPLATE FUNCTIONS                         |
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Is new bar                                                       |
//+------------------------------------------------------------------+
bool isNewBar() {
   if (stopper == Time[1]) {
      stopper = Time[0];
      return true;
   } else {
      return false;
   }
}
//+------------------------------------------------------------------+
//| Update news feed variables                                       |
//+------------------------------------------------------------------+
void updateNewsFeedVar(string news, string time) {
   //updateNewsFeedVar("news", StringSubstr(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES), 5, StringLen(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES))));
   
   NFV8=NFV7;
   NFV7=NFV6;
   NFV6=NFV5;
   NFV5=NFV4;
   NFV4=NFV3;
   NFV3=NFV2;
   NFV2=NFV1;
   NFV1=news;
   NFTV8=NFTV7;
   NFTV7=NFTV6;
   NFTV6=NFTV5;
   NFTV5=NFTV4;
   NFTV4=NFTV3;
   NFTV3=NFTV2;
   NFTV2=NFTV1;
   NFTV1=time;
   if (displayNF && !HUDMinimized) {
      updateNewsFeedObj();
   }
}
//+------------------------------------------------------------------+
//| Update news feed objects                                         |
//+------------------------------------------------------------------+
void updateNewsFeedObj() {
   ObjectSetString(ChartID(), "NFHUD1", OBJPROP_TEXT, NFV1);
   ObjectSetString(ChartID(), "NFHUD2", OBJPROP_TEXT, NFV2);
   ObjectSetString(ChartID(), "NFHUD3", OBJPROP_TEXT, NFV3);
   ObjectSetString(ChartID(), "NFHUD4", OBJPROP_TEXT, NFV4);
   ObjectSetString(ChartID(), "NFHUD5", OBJPROP_TEXT, NFV5);
   ObjectSetString(ChartID(), "NFHUD6", OBJPROP_TEXT, NFV6);
   ObjectSetString(ChartID(), "NFHUD7", OBJPROP_TEXT, NFV7);
   ObjectSetString(ChartID(), "NFHUD8", OBJPROP_TEXT, NFV8);
   ObjectSetString(ChartID(), "NFTHUD1", OBJPROP_TEXT, NFTV1);
   ObjectSetString(ChartID(), "NFTHUD2", OBJPROP_TEXT, NFTV2);
   ObjectSetString(ChartID(), "NFTHUD3", OBJPROP_TEXT, NFTV3);
   ObjectSetString(ChartID(), "NFTHUD4", OBJPROP_TEXT, NFTV4);
   ObjectSetString(ChartID(), "NFTHUD5", OBJPROP_TEXT, NFTV5);
   ObjectSetString(ChartID(), "NFTHUD6", OBJPROP_TEXT, NFTV6);
   ObjectSetString(ChartID(), "NFTHUD7", OBJPROP_TEXT, NFTV7);
   ObjectSetString(ChartID(), "NFTHUD8", OBJPROP_TEXT, NFTV8);
}
//+------------------------------------------------------------------+
//| Create HUD rectangle                                             |
//+------------------------------------------------------------------+
void createHUDRectangle() {
   if(!ObjectCreate(ChartID(),"HUD",OBJ_RECTANGLE_LABEL,0,0,0))
        {
         Print(
               ": failed to create a rectangle label! Error code = ",GetLastError());
        }
   //--- set label coordinates
      ObjectSetInteger(ChartID(),"HUD",OBJPROP_XDISTANCE,300);
      ObjectSetInteger(ChartID(),"HUD",OBJPROP_YDISTANCE,20);
   //--- set label size
      ObjectSetInteger(ChartID(),"HUD",OBJPROP_XSIZE,280);
      ObjectSetInteger(ChartID(),"HUD",OBJPROP_YSIZE,370);
   //--- set background color
      ObjectSetInteger(ChartID(),"HUD",OBJPROP_BGCOLOR,clrBlack);
   //--- set border type
      ObjectSetInteger(ChartID(),"HUD",OBJPROP_BORDER_TYPE,BORDER_FLAT);
   //--- set the chart's corner, relative to which point coordinates are defined
      ObjectSetInteger(ChartID(),"HUD",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
   //--- set flat border color (in Flat mode)
      ObjectSetInteger(ChartID(),"HUD",OBJPROP_COLOR,clrWhite);
   //--- set flat border line style
      ObjectSetInteger(ChartID(),"HUD",OBJPROP_STYLE,STYLE_SOLID);
   //--- set flat border width
      ObjectSetInteger(ChartID(),"HUD",OBJPROP_WIDTH,1);
   //--- display in the foreground (false) or background (true)
      ObjectSetInteger(ChartID(),"HUD",OBJPROP_BACK,false);
   //--- enable (true) or disable (false) the mode of moving the label by mouse
      ObjectSetInteger(ChartID(),"HUD",OBJPROP_SELECTABLE,false);
      ObjectSetInteger(ChartID(),"HUD",OBJPROP_SELECTED,false);
   //--- hide (true) or display (false) graphical object name in the object list
      ObjectSetInteger(ChartID(),"HUD",OBJPROP_HIDDEN,true);
   //--- set the priority for receiving the event of a mouse click in the chart
      ObjectSetInteger(ChartID(),"HUD",OBJPROP_ZORDER,0);
}
//+------------------------------------------------------------------+
//| Create Bitmap Label object                                       |
//+------------------------------------------------------------------+
bool BitmapLabelCreate(const long              chart_ID=0,               // chart's ID
                       const string            name2="BmpLabel",          // label name
                       const int               sub_window=0,             // subwindow index
                       const int               x=0,                      // X coordinate
                       const int               y=0,                      // Y coordinate
                       const string            file_on="",               // image in On mode
                       const string            file_off="",              // image in Off mode
                       const int               width=0,                  // visibility scope X coordinate
                       const int               height=0,                 // visibility scope Y coordinate
                       const int               x_offset=10,              // visibility scope shift by X axis
                       const int               y_offset=10,              // visibility scope shift by Y axis
                       const bool              state=false,              // pressed/released
                       const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, // chart corner for anchoring
                       const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, // anchor type 
                       const color             clr=clrRed,               // border color when highlighted
                       const ENUM_LINE_STYLE   style=STYLE_SOLID,        // line style when highlighted
                       const int               point_width=1,            // move point size
                       const bool              back=false,               // in the background
                       const bool              selection=false,          // highlight to move
                       const bool              hidden=true,              // hidden in the object list
                       const long              z_order=0)                // priority for mouse click
  {
//--- reset the error value
   ResetLastError();
//--- create a bitmap label
   if(!ObjectCreate(chart_ID,name2,OBJ_BITMAP_LABEL,sub_window,0,0))
     {
      Print(__FUNCTION__,
            ": failed to create \"Bitmap Label\" object! Error code = ",GetLastError());
      return(false);
     }
//--- set the images for On and Off modes
   if(!ObjectSetString(chart_ID,name2,OBJPROP_BMPFILE,0,file_on))
     {
      Print(__FUNCTION__,
            ": failed to load the image for On mode! Error code = ",GetLastError());
      return(false);
     }
   if(!ObjectSetString(chart_ID,name2,OBJPROP_BMPFILE,1,file_off))
     {
      Print(__FUNCTION__,
            ": failed to load the image for Off mode! Error code = ",GetLastError());
      return(false);
     }
//--- set label coordinates
   ObjectSetInteger(chart_ID,name2,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name2,OBJPROP_YDISTANCE,y);
//--- set visibility scope for the image; if width or height values
//--- exceed the width and height (respectively) of a source image,
//--- it is not drawn; in the opposite case,
//--- only the part corresponding to these values is drawn
   ObjectSetInteger(chart_ID,name2,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name2,OBJPROP_YSIZE,height);
//--- set the part of an image that is to be displayed in the visibility scope
//--- the default part is the upper left area of an image; the values allow
//--- performing a shift from this area displaying another part of the image
   ObjectSetInteger(chart_ID,name2,OBJPROP_XOFFSET,x_offset);
   ObjectSetInteger(chart_ID,name2,OBJPROP_YOFFSET,y_offset);
//--- define the label's status (pressed or released)
   ObjectSetInteger(chart_ID,name2,OBJPROP_STATE,state);
//--- set the chart's corner, relative to which point coordinates are defined
   ObjectSetInteger(chart_ID,name2,OBJPROP_CORNER,corner);
//--- set anchor type
   ObjectSetInteger(chart_ID,name2,OBJPROP_ANCHOR,anchor);
//--- set the border color when object highlighting mode is enabled
   ObjectSetInteger(chart_ID,name2,OBJPROP_COLOR,clr);
//--- set the border line style when object highlighting mode is enabled
   ObjectSetInteger(chart_ID,name2,OBJPROP_STYLE,style);
//--- set a size of the anchor point for moving an object
   ObjectSetInteger(chart_ID,name2,OBJPROP_WIDTH,point_width);
//--- display in the foreground (false) or background (true)
   ObjectSetInteger(chart_ID,name2,OBJPROP_BACK,back);
//--- enable (true) or disable (false) the mode of moving the label by mouse
   ObjectSetInteger(chart_ID,name2,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name2,OBJPROP_SELECTED,selection);
//--- hide (true) or display (false) graphical object name in the object list
   ObjectSetInteger(chart_ID,name2,OBJPROP_HIDDEN,hidden);
//--- set the priority for receiving the event of a mouse click in the chart
   ObjectSetInteger(chart_ID,name2,OBJPROP_ZORDER,z_order);
//--- successful execution
   return(true);
  }
//+------------------------------------------------------------------+
//|                           FUNCTIONS                              |
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Currency net profit                                              |
//+------------------------------------------------------------------+
double currencyNetProfit() {
   double NP = 0;
   double CNPV = 0;
   double OPNP=0;
   double CPNP=0;
   for (int i=0; i<OrdersTotal(); i++) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol()==Symbol()) {
            NP += OrderProfit()-OrderCommission()+OrderSwap();
         }
      } else {
         Print("Orderselect error: "+IntegerToString(GetLastError()));
      }
   }
   OPNP=NP;
   for (int i=OrdersHistoryTotal()-1; i>=0; i--) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
         if (OrderSymbol()==Symbol() && OrderOpenTime()>startTime) {
            NP += OrderProfit()-OrderCommission()+OrderSwap();
            CNPV += OrderProfit()-OrderCommission()+OrderSwap();
         }
      } else {
         Print("Orderselect error: "+IntegerToString(GetLastError()));
      }
   }
   CPNP = CNPV;
   return NP;
}
//+------------------------------------------------------------------+
//| Close pair orders                                                |
//+------------------------------------------------------------------+
void closePairOrders(bool isLong)
{ int k=-1,j=0;
   bool order_found= false;
   for(j=0;j<500;j++) ord_arr[j]=0;
   
   int ot = OrdersTotal();
   for(j=ot-1;j>=0;j--)
   {
      if(OrderSelect(j,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==magicNumber)
      {   
         if( (OrderType()==OP_SELL || OrderType()==OP_BUY)   )
         {  k = k + 1; 
            ord_arr[k]=OrderTicket();
         }
      }     
    }
    for(j=0;j<=k;j++)
    {  OrderClosed=false;
       tries=0;
       while(!OrderClosed && tries<10)
            {
               order_found=OrderSelect(ord_arr[j],SELECT_BY_TICKET,MODE_TRADES);
               if (isLong) {
                  if(OrderType()==OP_BUY && order_found) OrderClosed=OrderClose(ord_arr[j],OrderLots(),Bid,10,NULL);               
               } else {
                  if(OrderType()==OP_SELL && order_found) OrderClosed=OrderClose(ord_arr[j],OrderLots(),Ask,10,NULL);               
               }
               if(order_found && !OrderClosed)              
               tries=tries+1;
            }
    }
}
//+------------------------------------------------------------------+
//| Send order                                                       |
//+------------------------------------------------------------------+
void orderSend(bool isLong, double entryPrice, int SLIndex) {
   double usedVol;
   for (int i=0; i<1000; i++) {
      if (isLong) {
         if (longEntryPricesArray[i]!=0 && longEntryPricesArray[i]==entryPrice) {
            longEntryCountArray[i]+=1;
            usedVol=volume*longEntryCountArray[i];
            break;
         }
         if (longEntryPricesArray[i]==0) {
            longEntryPricesArray[i]=entryPrice;
            longEntryCountArray[i]+=1;
            usedVol=volume*longEntryCountArray[i];
            break;
         }
      } else {
         if (shortEntryPricesArray[i]!=0 && shortEntryPricesArray[i]==entryPrice) {
            shortEntryCountArray[i]+=1;
            usedVol=volume*shortEntryCountArray[i];
            break;
         }
         if (shortEntryPricesArray[i]==0) {
            shortEntryPricesArray[i]=entryPrice;
            shortEntryCountArray[i]+=1;
            usedVol=volume*shortEntryCountArray[i];
            break;
         }
      }
   }
   
   if (isLong) {
      int L=OrderSend(Symbol(),OP_BUY,NormalizeDouble(usedVol,normalizer),Ask,maxAllowedSlippage,gridArray[SLIndex],0,"Trend following EA",magicNumber,0,0);
      if (L<0) {
         Alert("Long ordersend failed with error: "+IntegerToString(GetLastError()));
         updateNewsFeedVar("Long error "+IntegerToString(GetLastError()), StringSubstr(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES), 5, StringLen(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES))));
      } else {
         lastBuyTicket=L;
      }
   } else {
      int S=OrderSend(Symbol(),OP_SELL,NormalizeDouble(usedVol,normalizer),Bid,maxAllowedSlippage,gridArray[SLIndex],0,"Trend following EA",magicNumber,0,0);
      if (S<0) {
         Alert("Short ordersend failed with error: "+IntegerToString(GetLastError()));
         updateNewsFeedVar("Short error "+IntegerToString(GetLastError()), StringSubstr(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES), 5, StringLen(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES))));
      } else {
         lastSellTicket=S;
      }
   }
}
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
  
   startPrice=Bid;
   startTime=TimeCurrent();
  
   //**--TEMPLATE
   lotStep = MarketInfo(Symbol(), MODE_LOTSTEP);   
   if (lotStep==0.01) {
      normalizer=2;
   } else if (lotStep==0.1) {
      normalizer=1;
   } else if (lotStep==1) {
      normalizer=0;
   }
   
   
   maxAllowedSlippage=maxAllowedSlippageInp;
   gridSize=gridSizeInp;
   
   if (Digits==3 || Digits==5) {
      digiter=10;
      maxAllowedSlippage*=10;
      gridSize*=10;
   } else {
      digiter=1;
   }
   
   gridArray[500]=Bid;
   if (showGrid) {
      ObjectCreate(ChartID(),"Grid level "+DoubleToStr(gridArray[500],Digits()),OBJ_HLINE,0,0,gridArray[500]);
      ObjectSetInteger(ChartID(),"Grid level "+DoubleToStr(gridArray[500],Digits()),OBJPROP_COLOR,gridColor);
      ObjectSetInteger(ChartID(),"Grid level "+DoubleToStr(gridArray[500],Digits()),OBJPROP_BACK,true);
      ObjectSetInteger(ChartID(),"Grid level "+DoubleToStr(gridArray[500],Digits()),OBJPROP_STYLE,gridStyle);
   }
   
   for (int i=501; i<1001; i++) {
      gridArray[i]=Bid+(gridSize*(i-500))*Point;
      if (showGrid) {
         ObjectCreate(ChartID(),"Grid level "+DoubleToStr(gridArray[i],Digits()),OBJ_HLINE,0,0,gridArray[i]);
         ObjectSetInteger(ChartID(),"Grid level "+DoubleToStr(gridArray[i],Digits()),OBJPROP_COLOR,gridColor);
         ObjectSetInteger(ChartID(),"Grid level "+DoubleToStr(gridArray[i],Digits()),OBJPROP_BACK,true);
         ObjectSetInteger(ChartID(),"Grid level "+DoubleToStr(gridArray[i],Digits()),OBJPROP_STYLE,gridStyle);
      }
   }
   for (int i=499; i>=0; i--) {
      gridArray[i]=Bid-(gridSize*(500-i))*Point;
      if (showGrid) {
         ObjectCreate(ChartID(),"Grid level "+DoubleToStr(gridArray[i],Digits()),OBJ_HLINE,0,0,gridArray[i]);
         ObjectSetInteger(ChartID(),"Grid level "+DoubleToStr(gridArray[i],Digits()),OBJPROP_COLOR,gridColor);
         ObjectSetInteger(ChartID(),"Grid level "+DoubleToStr(gridArray[i],Digits()),OBJPROP_BACK,true);
         ObjectSetInteger(ChartID(),"Grid level "+DoubleToStr(gridArray[i],Digits()),OBJPROP_STYLE,gridStyle);
      }
   }
   
   upperGridPrice=gridArray[501];
   lowerGridPrice=gridArray[499];
   lastEntryIndex=500;
   runEA=true;
   
   for (int i=0; i<999; i++) {
      longEntryCountArray[i]=0;
      longEntryPricesArray[i]=0;
      shortEntryCountArray[i]=0;
      shortEntryPricesArray[i]=0;
   }
   
   
   
   /*ObjectCreate(ChartID(),"Upper close price",OBJ_HLINE,0,0,upperClosePrice);
   ObjectSetInteger(ChartID(),"Upper close price",OBJPROP_WIDTH,1);
   ObjectSetInteger(ChartID(),"Upper close price",OBJPROP_COLOR,clrBlueViolet);
   
   ObjectCreate(ChartID(),"Lower close price",OBJ_HLINE,0,0,lowerClosePrice);
   ObjectSetInteger(ChartID(),"Lower close price",OBJPROP_WIDTH,1);
   ObjectSetInteger(ChartID(),"Lower close price",OBJPROP_COLOR,clrBlueViolet);*/
   
   ObjectCreate(ChartID(),"Close button",OBJ_BUTTON,0,0,0);
   ObjectSet("Close button",OBJPROP_BGCOLOR,clrBlack);
   ObjectSet("Close button",OBJPROP_CORNER,CORNER_LEFT_UPPER);
   ObjectSet("Close button",OBJPROP_YDISTANCE,40);
   ObjectSet("Close button",OBJPROP_XDISTANCE,10);
   ObjectSet("Close button",OBJPROP_XSIZE,150);
   ObjectSet("Close button",OBJPROP_YSIZE,50);   
   ObjectSetString(ChartID(),"Close button",OBJPROP_TEXT,"Close all");
   ObjectSet("Close button",OBJPROP_COLOR,White);
   
   if (displayNF) {
      HUDMinimized=false;
      createHUDRectangle();
      BitmapLabelCreate(0,"BLabel",0,270,30,InpFile,InpFile,InpWidth,InpHeight,InpXOffset,InpYOffset,false,
         CORNER_RIGHT_UPPER,ANCHOR_LEFT_UPPER,InpColor,InpStyle,InpPointWidth,InpBack,InpSelection,InpHidden,InpZOrder);
      ObjectCreate(ChartID(),"Minimize button",OBJ_BUTTON,0,0,0);
      ObjectSet("Minimize button",OBJPROP_BGCOLOR,clrBlack);
      ObjectSet("Minimize button",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSet("Minimize button",OBJPROP_YDISTANCE,21);
      ObjectSet("Minimize button",OBJPROP_XDISTANCE,41);
      ObjectSet("Minimize button",OBJPROP_XSIZE,20);
      ObjectSet("Minimize button",OBJPROP_YSIZE,20);   
      ObjectSetString(ChartID(),"Minimize button",OBJPROP_TEXT,"-");
      ObjectSet("Minimize button",OBJPROP_COLOR,White);
      
      
      nameNF="NFTHUD1";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,149);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      nameNF="NFHUD1";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,161);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      nameNF="NFTHUD2";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,178);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      nameNF="NFHUD2";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,190);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      nameNF="NFTHUD3";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,207);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      nameNF="NFHUD3";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,219);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      nameNF="NFTHUD4";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,236);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      nameNF="NFHUD4";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,248);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      nameNF="NFTHUD5";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,265);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      nameNF="NFHUD5";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,277);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      nameNF="NFTHUD6";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,294);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      nameNF="NFHUD6";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,306);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      nameNF="NFTHUD7";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,323);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      nameNF="NFHUD7";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,335);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      nameNF="NFTHUD8";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,352);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      nameNF="NFHUD8";
      ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
      ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
      ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,364);
      ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
      ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
      ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
      ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
      ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
      ObjectSetString(0,nameNF,OBJPROP_TEXT,"");
      
      updateNewsFeedVar("EA started", StringSubstr(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES), 5, StringLen(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES))));
   }
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   if (displayNF) {
      ObjectDelete(ChartID(), "BLabel");
      ObjectDelete(ChartID(), "HUD");
      ObjectDelete(ChartID(), "Minimize button");
      ObjectDelete(ChartID(), "NFTHUD1");
      ObjectDelete(ChartID(), "NFHUD1");
      ObjectDelete(ChartID(), "NFTHUD2");
      ObjectDelete(ChartID(), "NFHUD2");
      ObjectDelete(ChartID(), "NFTHUD3");
      ObjectDelete(ChartID(), "NFHUD3");
      ObjectDelete(ChartID(), "NFTHUD4");
      ObjectDelete(ChartID(), "NFHUD4");
      ObjectDelete(ChartID(), "NFTHUD5");
      ObjectDelete(ChartID(), "NFHUD5");
      ObjectDelete(ChartID(), "NFTHUD6");
      ObjectDelete(ChartID(), "NFHUD6");
      ObjectDelete(ChartID(), "NFTHUD7");
      ObjectDelete(ChartID(), "NFHUD7");
      ObjectDelete(ChartID(), "NFTHUD8");
      ObjectDelete(ChartID(), "NFHUD8");
   }
   ObjectDelete(ChartID(), "Upper close price");
   ObjectDelete(ChartID(), "Lower close price");
   ObjectDelete(ChartID(), "Close button");
   
   if (showGrid) {
      for (int i=0; i<1001; i++) {
         ObjectDelete(ChartID(), "Grid level "+DoubleToStr(gridArray[i],Digits()));
      }
   }
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   if (runEA) {
      if (Ask>=upperGridPrice) {
         OrderClose(lastSellTicket,volume,Ask,maxAllowedSlippage,0);
         if (TD==2 || (TD==0 && Ask>startPrice)) {
            orderSend(true,upperGridPrice,lastEntryIndex);
         }
         lastEntryIndex++;
         upperGridPrice=gridArray[lastEntryIndex+1];
         lowerGridPrice=gridArray[lastEntryIndex-1];
      }
      if (Bid<=lowerGridPrice) {
         OrderClose(lastBuyTicket,volume,Bid,maxAllowedSlippage,0);
         if (TD==2 || (TD==1 && Bid<startPrice)) {
            orderSend(false,lowerGridPrice,lastEntryIndex);
         }
         lastEntryIndex--;
         upperGridPrice=gridArray[lastEntryIndex+1];
         lowerGridPrice=gridArray[lastEntryIndex-1];
      }
      
      if (currencyNetProfit()>=netProfitTarget) {
         closePairOrders(true);
         closePairOrders(false);
         Alert("Close everything due to net profit reach!");
         updateNewsFeedVar("Net profit reached!", StringSubstr(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES), 5, StringLen(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES))));
         updateNewsFeedVar("Net profit reached!", StringSubstr(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES), 5, StringLen(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES))));
         runEA=false;
      }
      
      Comment("Net profit of this EA sequence: "+currencyNetProfit());
      
      /*if (Bid>=upperClosePrice) {
         closePairOrders(true);
         closePairOrders(false);
         Alert("Close everything due to upper level breach!");
         updateNewsFeedVar("Upper level close!", StringSubstr(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES), 5, StringLen(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES))));
         updateNewsFeedVar("Please restart the EA", StringSubstr(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES), 5, StringLen(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES))));
         runEA=false;
      }
      if (Bid<=lowerClosePrice) {
         closePairOrders(true);
         closePairOrders(false);
         Alert("Close everything due to lower level breach!");
         updateNewsFeedVar("Lower level close!", StringSubstr(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES), 5, StringLen(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES))));
         updateNewsFeedVar("Please restart the EA", StringSubstr(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES), 5, StringLen(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES))));
         runEA=false;
      }*/
   }
   
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam) {
   if (id==CHARTEVENT_OBJECT_CLICK) {
      if (sparam=="Minimize button") {
            if (!HUDMinimized) {
               //Delete HUD elements
               ObjectDelete(ChartID(), "BLabel");
               ObjectDelete(ChartID(), "HUD");
               ObjectDelete(ChartID(), "NFTHUD1");
               ObjectDelete(ChartID(), "NFHUD1");
               ObjectDelete(ChartID(), "NFTHUD2");
               ObjectDelete(ChartID(), "NFHUD2");
               ObjectDelete(ChartID(), "NFTHUD3");
               ObjectDelete(ChartID(), "NFHUD3");
               ObjectDelete(ChartID(), "NFTHUD4");
               ObjectDelete(ChartID(), "NFHUD4");
               ObjectDelete(ChartID(), "NFTHUD5");
               ObjectDelete(ChartID(), "NFHUD5");
               ObjectDelete(ChartID(), "NFTHUD6");
               ObjectDelete(ChartID(), "NFHUD6");
               ObjectDelete(ChartID(), "NFTHUD7");
               ObjectDelete(ChartID(), "NFHUD7");
               ObjectDelete(ChartID(), "NFTHUD8");
               ObjectDelete(ChartID(), "NFHUD8");
               HUDMinimized=true;
            } else {
               //Recreate HUD elements and if necessary (if new elements hide minimize button), recreate the button, UPDATE NF OBJECTS!
               ObjectDelete(ChartID(), "Minimize button");
               createHUDRectangle();
               BitmapLabelCreate(0,"BLabel",0,270,30,InpFile,InpFile,InpWidth,InpHeight,InpXOffset,InpYOffset,false,
                  CORNER_RIGHT_UPPER,ANCHOR_LEFT_UPPER,InpColor,InpStyle,InpPointWidth,InpBack,InpSelection,InpHidden,InpZOrder);
               ObjectCreate(ChartID(),"Minimize button",OBJ_BUTTON,0,0,0);
               ObjectSet("Minimize button",OBJPROP_BGCOLOR,clrBlack);
               ObjectSet("Minimize button",OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSet("Minimize button",OBJPROP_YDISTANCE,21);
               ObjectSet("Minimize button",OBJPROP_XDISTANCE,41);
               ObjectSet("Minimize button",OBJPROP_XSIZE,20);
               ObjectSet("Minimize button",OBJPROP_YSIZE,20);   
               ObjectSetString(ChartID(),"Minimize button",OBJPROP_TEXT,"-");
               ObjectSet("Minimize button",OBJPROP_COLOR,White);
               
               
               nameNF="NFTHUD1";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,149);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               
               nameNF="NFHUD1";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,161);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               
               nameNF="NFTHUD2";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,178);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               
               nameNF="NFHUD2";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,190);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               
               nameNF="NFTHUD3";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,207);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               
               nameNF="NFHUD3";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,219);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               
               nameNF="NFTHUD4";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,236);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               
               nameNF="NFHUD4";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,248);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               
               nameNF="NFTHUD5";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,265);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               
               nameNF="NFHUD5";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,272);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               
               nameNF="NFTHUD6";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,289);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               
               nameNF="NFHUD6";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,301);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               
               nameNF="NFTHUD7";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,318);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               
               nameNF="NFHUD7";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,330);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               
               nameNF="NFTHUD8";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,285);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,347);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               
               nameNF="NFHUD8";
               ObjectCreate(nameNF,OBJ_LABEL,0,0,0);
               ObjectSetInteger(0,nameNF,OBJPROP_XDISTANCE,265);
               ObjectSetInteger(0,nameNF,OBJPROP_YDISTANCE,359);
               ObjectSetInteger(0,nameNF,OBJPROP_XSIZE,250);
               ObjectSetInteger(0,nameNF,OBJPROP_YSIZE,30);
               ObjectSetInteger(0,nameNF,OBJPROP_CORNER,CORNER_RIGHT_UPPER);
               ObjectSetInteger(0,nameNF,OBJPROP_FONTSIZE,10);
               ObjectSetInteger(0,nameNF,OBJPROP_COLOR,clrWhite);
               updateNewsFeedObj();
               HUDMinimized=false;
            }
      } else if (sparam=="Close button") {
         if (runEA) {
            closePairOrders(true);
            closePairOrders(false);
            Alert("Closing everything!");
            updateNewsFeedVar("Closing everything!", StringSubstr(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES), 5, StringLen(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES))));
            updateNewsFeedVar("Please restart the EA", StringSubstr(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES), 5, StringLen(TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES))));
            ObjectDelete(ChartID(),"Close button");
            runEA=false;
         }
      }
   }
   
}